package eu.clarin.cqi.apps;

import eu.clarin.cqi.ws.resources.CQPResource;
import java.util.Collections;
import java.util.Set;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.ws.rs.ApplicationPath;
import javax.ws.rs.core.Application;

/**
 *
 * @author akislev
 */
@ApplicationPath("cqp")
public class CQPApplication extends Application {

    @Override
    public Set<Object> getSingletons() {
        CQPResource resource = new CQPResource();
        try {
            InitialContext context = new InitialContext();
            String cqiServerHostname = (String) context.lookup("java:comp/env/cqi-server-hostname");
            if (cqiServerHostname == null || cqiServerHostname.isEmpty()) {
                throw new RuntimeException("cqi-server-hostname <env-entry> is not specified in web.xml");
            }
            resource.setCqiServerHostname(cqiServerHostname);
            Integer cqiServerPort = (Integer) context.lookup("java:comp/env/cqi-server-port");
            if (cqiServerPort == null) {
                throw new RuntimeException("cqi-server-port <env-entry> is not specified in web.xml");
            }
            resource.setCqiServerPort(cqiServerPort);
            String cqiServerUsername = (String) context.lookup("java:comp/env/cqi-server-username");
            if (cqiServerUsername == null || cqiServerUsername.isEmpty()) {
                throw new RuntimeException("cqi-server-username <env-entry> is not specified in web.xml");
            }
            resource.setCqiServerUsername(cqiServerUsername);
            String cqiServerPassword = (String) context.lookup("java:comp/env/cqi-server-password");
            if (cqiServerPassword == null || cqiServerPassword.isEmpty()) {
                throw new RuntimeException("cqi-server-password <env-entry> is not specified in web.xml");
            }
            resource.setCqiServerPassword(cqiServerPassword);
            Integer maxQueryResults = (Integer) context.lookup("java:comp/env/max-query-results");
            if (maxQueryResults == null) {
                throw new RuntimeException("max-query-results <env-entry> is not specified in web.xml");
            }
            resource.setMaxQueryResults(maxQueryResults);
        } catch (NamingException ex) {
            throw new RuntimeException(ex.getExplanation(), ex);
        }
        return Collections.<Object>singleton(resource);
    }
}
